
library IEEE;
use IEEE.std_logic_1164.ALL;
use IEEE.std_logic_arith.ALL;
use IEEE.std_logic_unsigned.ALL;

entity Master_top is

    Port ( 	CLK_50  : in  std_logic;
			x 		: in  std_logic;
			RESET 	: in  std_logic;
			Datain	: in  std_logic_vector( 15 DOWNTO 0);
			SCLK 	: out std_logic;
			MOSI 	: out std_logic;
			MISO 	: in  std_logic;
			CS1		: out std_logic);  -- Slave Chip Select#1 
end Master_top;

architecture RTL of Master_top is

-------------------------------------------------------------
component Master
    Port ( 	CLK  	: in   std_logic;
			RESET 	: in   std_logic;
			Datain	: in   std_logic_vector( 15 DOWNTO 0);
			SCLK 	: out  std_logic;
			MOSI 	: out  std_logic;
			MISO 	: in   std_logic;
			CS1		: out  std_logic);  -- Slave Chip Select#1 
end component;
--------------------------------------------------------------

component spi_clock
	  Port (
			CLK_50 	: in  std_logic;
			x 		: in  std_logic;
			DBx 	: out std_logic);
end component;


-------- spi_Debounce  --------
signal clk_signal 	: std_logic;
signal CLK 			: std_logic;
----------------------------------------------------------

begin

dut2 : spi_clock
port map (
			CLK_50  => CLK_50,  	
			x 	=>  x, 	
			DBx	=>  clk_signal );	-- DBx  : out  std_logic
									-- CLK  : in   std_logic
									
dut1 : Master
port map (
			CLK  	=> CLK,  	
			RESET 	=> RESET, 	
			Datain	=> Datain,	
			SCLK 	=> SCLK, 	
			MOSI 	=> MOSI, 	
			MISO 	=> MISO, 	
			CS1		=> CS1);	
--------------------------------------		
--clk_signal 	<= DBx;
CLK 		<= clk_signal;
---------------------------------------


end RTL;


